<?php
require_once "blesta_api.php";

$user = "handoyo";
$key  = "e012096d9c135007ff4219863c1b048b";
$url  = "https://abdev7.com/blesta/api/";

$api = new BlestaApi( $url, $user, $key );

//$info = $api->get("license_keys.license_keys_list","getClientIdByExtensionName",array(
//    'extension_name' => 'ShipEngine Integration'
//));

$timezoneInfo = $api->get("companies","getSetting",array(
    'company_id' => 1,
    'key' => 'timezone'
));

$getTimeZoneResult = $timezoneInfo->response();
$getTimeZoneErr    = $timezoneInfo->errors();

$timezone = $getTimeZoneResult->value;
$info = $api->get("license_keys.license_keys_list","getClientIds");

$getClientsResult = $info->response();
$getClientsErr    = $info->errors();

foreach ($getClientsResult as $clients) {
    $client_id = $clients->client_id;
    $email = $clients->email;
    $getInvoiceList = $api->get( "license_keys.invoices_list", "getList", array(
        'client_id' => $client_id,
        'status' => 'closed',
        'order_by' => array(
            'date_due' => 'DESC'
        )
    ) );

    $getInvoiceListResult = $getInvoiceList->response();
    $getInvoiceListErr    = $getInvoiceList->errors();

    if ($getInvoiceListResult) {
        foreach ($getInvoiceListResult as $invoices) {
            //$invoices = current($getInvoiceListResult);

            $due = $invoices->due;
            $invoice_id = $invoices->id;
            $getInvoicesDetail = $api->get("invoices", "getLineItems", array(
                'invoice_id' => $invoice_id
            ));
            $getInvoicesDetailResult = $getInvoicesDetail->response();
            $getInvoicesDetailErr = $getInvoicesDetail->errors();

            if ($getInvoicesDetailResult) {
                foreach ($getInvoicesDetailResult as $invoice_detail) {
                    $service_id = $invoice_detail->service_id;
                    $amount = $invoice_detail->amount;
                    if (is_null($service_id) || $amount === '0.0000') {
                        continue;
                    }
                    $description = explode(' - ', $invoice_detail->description);
                    $service_name = $description[0];
                    $service_detail = $api->get("services", "get", array(
                        'service_id' => $service_id
                    ));

                    $serviceDetailResult = $service_detail->response();
                    $serviceDetailErr = $service_detail->errors();

                    $renewed_date = date_create($serviceDetailResult->date_renews,new DateTimeZone($timezone))->format('Y-m-d');
                    $last_renewed = date_create($serviceDetailResult->date_last_renewed,new DateTimeZone($timezone))->format('Y-m-d');
                    $service_price = $serviceDetailResult->package_pricing->price_renews;
                    if ($due === $service_price || $serviceDetailResult->status === 'canceled') {
                        continue;
                    }

                    $licenseInfo = $api->get("license_keys.license_keys_list", "getLicenseId", array(
                        'service_id' => $service_id
                    ));
                    $licenseInfoResult = $licenseInfo->response();
                    $licenseInfoErr = $licenseInfo->errors();
                    $getProductId = getProductId($service_name);
                    $data['product_id'] = $getProductId['page_message'][0]['product_id'];

                    if ($licenseInfoResult) {
                        $data['license_id'] = $licenseInfoResult->license_id;
                        $data['license_code'] = $licenseInfoResult->license_code;

                        if (is_null($licenseInfoResult->renewed_date)) {
                            $listing_renewed_date = '';
                        } else {
                            $listing_renewed_date =  date_create($licenseInfoResult->renewed_date,new DateTimeZone($timezone))->format('Y-m-d');
                        }

                        $due_date =  date_create($invoices->date_due,new DateTimeZone($timezone))->format('Y-m-d');
                        $paid_date =  date_create($invoices->date_closed,new DateTimeZone($timezone))->format('Y-m-d');

                        //echo $invoices->date_due.','.$invoices->date_closed.','.$listing_renewed_date.'<br>';
                        //if ($due_date === $last_renewed && $paid_date !== '') {
                        //if ($paid_date!==)

                        $admDateTo = 'yonghan79@gmail.com';
                        $admDateSubject = "Date information";
                        $admDateHeaders = "From: Support Departement <support@abdev7.com>" . "\r\n";
                        $admDateHeaders .= "Reply-To: support@wehearyou2.com" . "\r\n";
                        $admDateHeaders .= "Return-Path: support@wehearyou2.com " . "\r\n";
                        $admDateHeaders .= "MIME-Version: 1.0" . "\r\n";
                        $admDateHeaders .= "Content-Type: text/html; charset=utf-8" . "\r\n";
                        mail($admDateTo, $admDateSubject, 'Listing renewed date:' . $listing_renewed_date . ',' . ' paid date: ' . $paid_date . ',renewal date: ' . $renewed_date.', '.date_create($serviceDetailResult->date_renews)->format('Y-m-d'), $admDateHeaders);
                        if ($listing_renewed_date !== $paid_date) {
                            $data['expire_date'] = $renewed_date;
                            $result = updateLicense($data);
                            $updateRenewDate = $api->post("license_keys.license_keys_list", "updateRenewDate", array(
                                'service_id' => $service_id,
                                'renewal_date' => $renewed_date,
                                'renewed_date' => $paid_date
                            ));
                            $updateRenewDateResult = $updateRenewDate->response();
                            $updateRenewDateErr = $updateRenewDate->errors();

                            $emailTo = $email;
                            $emailSubject = "Support renewal success";
                            $emailHeaders = "From: Support Departement <support@abdev7.com>" . "\r\n";
                            $emailHeaders .= "Reply-To: support@wehearyou2.com" . "\r\n";
                            $emailHeaders .= "Return-Path: support@wehearyou2.com " . "\r\n";
                            $emailHeaders .= "MIME-Version: 1.0" . "\r\n";
                            $emailHeaders .= "Content-Type: text/html; charset=utf-8" . "\r\n";

                            $product_name =  $serviceDetailResult->package->name;
                            $message = 'Thank you for renewing your <strong>'.$product_name.'</strong> support. We have extended your support to <strong>'.$renewed_date.'</strong>.';

                            mail($emailTo, $emailSubject, $message, $emailHeaders);

                            $admTo = 'yonghan79@gmail.com';
                            $admSubject = "Update renew date";
                            $admHeaders = "From: Support Departement <support@abdev7.com>" . "\r\n";
                            $admHeaders .= "Reply-To: support@wehearyou2.com" . "\r\n";
                            $admHeaders .= "Return-Path: support@wehearyou2.com " . "\r\n";
                            $admHeaders .= "MIME-Version: 1.0" . "\r\n";
                            $admHeaders .= "Content-Type: text/html; charset=utf-8" . "\r\n";
                            mail($admTo, $admSubject, var_export($updateRenewDateResult, true), $admHeaders);
                            if ($updateRenewDateErr) {
                                $admSubject = "Update renew date error";
                                mail($admTo, $admSubject, var_export($updateRenewDateErr, true), $admHeaders);
                            }
                        }
                    }
                    //}
                }
            }
        }
    }

}

function updateLicense($data) {
        $url    = 'https://abdev7.com/licensing/apl_api/api.php';
        $client = 'api_key_secret=VHYXn3JozuCjls3v&api_function=licenses_edit&product_id='.$data['product_id'].'&license_id='.$data['license_id'].'&license_code='.trim($data['license_code']).'&license_require_domain=1&license_status=1&license_support_date='.$data['expire_date'];
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 3000,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS  => $client,
            CURLOPT_ENCODING => "",
            CURLOPT_HTTPHEADER => array(
                "accept: application/x-www-form-urlencoded",
                "cache-control: no-cache",
                "content-type: application/x-www-form-urlencoded"
            ),
            CURLOPT_VERBOSE => 0,
        ));
        $response = json_decode(curl_exec($curl),true);
        $err = curl_error($curl);
        curl_close($curl);
        $admTo      = 'yonghan79@gmail.com';
        $admSubject = "Update license code info";
        $admHeaders = "From: Support Departement <support@abdev7.com>" . "\r\n";
        $admHeaders .= "Reply-To: support@wehearyou2.com" . "\r\n";
        $admHeaders .= "Return-Path: support@wehearyou2.com " . "\r\n";
        $admHeaders .= "MIME-Version: 1.0" . "\r\n";
        $admHeaders .= "Content-Type: text/html; charset=utf-8" . "\r\n";
        mail( $admTo, $admSubject, var_export( $response, true ), $admHeaders );
        return $response;
}

function getProductId($product_name) {
        $url    = 'https://abdev7.com/licensing/apl_api/api.php';
        $client = 'api_key_secret=VHYXn3JozuCjls3v&api_function=search&search_type=product&search_keyword='.$product_name;

        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 3000,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS  => $client,
            CURLOPT_ENCODING => "",
            CURLOPT_HTTPHEADER => array(
                "accept: application/x-www-form-urlencoded",
                "cache-control: no-cache",
                "content-type: application/x-www-form-urlencoded"
            ),
            CURLOPT_VERBOSE => 0,
        ));
        $response = json_decode(curl_exec($curl),true);
        $err = curl_error($curl);
        curl_close($curl);

        return $response;
}